package com.fp.frontend.controller.pgeneral.message;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;

import org.primefaces.event.SelectEvent;

import com.fp.dto.Request;
import com.fp.dto.Response;
import com.fp.dto.query.DtoQuery;
import com.fp.dto.query.SubQuery;
import com.fp.dto.save.DtoSave;
import com.fp.frontend.controller.AbstractController;
import com.fp.frontend.controller.pgeneral.gene.LanguageController;
import com.fp.frontend.controller.pgeneral.lov.MessageTemplatesLovController;
import com.fp.frontend.helper.MessageHelper;
import com.fp.persistence.pgeneral.gene.TgeneLanguage;
import com.fp.persistence.pgeneral.message.TgeneMessageTemplates;
import com.fp.persistence.pgeneral.message.TgeneMessageTemplatesDesc;

/**
 * Clase controladora del bean TgeneMessageTemplatesDesc.
 *
 * @author WPA.
 * @version 2.1
 */
@ManagedBean
@ViewScoped
public class MessageTemplatesDescController extends AbstractController<TgeneMessageTemplatesDesc> {

    private static final long serialVersionUID = 1L;

    public MessageTemplatesDescController() throws Exception {
        super(TgeneMessageTemplatesDesc.class);
    }

    /**
     * Atributo para la lista de lenguajes
     */
    private List<TgeneLanguage> lLanguage;

    @PostConstruct
    private void postconstruct() {
        this.init();
        // Inicializa autoconsulta
        super.startQuery();
        //Lista
        this.lLanguage = LanguageController.find();

    }

    /**
     * Incializa el controlador, cuando se esta utilizando una pagina que utliza
     * el controlador.
     */
    private void init() {
        try {
            this.recperpage = 10; // Cambiar al # reg a mirar.
            this.lrecord = new ArrayList<>();
            this.beanalias = "MESSAGETEMPLATESDESC";
        } catch (Exception e) {
            MessageHelper.setMessageError(e);
        }
    }

    @SuppressWarnings("unchecked")
    @Override
    protected void querydatabase() {
        try {
            DtoQuery dto = super.getDtoQuery(true);
            dto.setOrderby("t.pk.code");

            // subqueries 1
            SubQuery subquery = new SubQuery("TgeneMessageTemplates", "description", "messagedescription",
                    "i.pk = t.pk.code");
            dto.addSubQuery(subquery);

            HashMap<String, DtoQuery> mtables = new HashMap<String, DtoQuery>();
            mtables.put(this.beanalias, dto); // permite adicionar mas de una tabla.

            Request request = this.callerhelper.getRequest();
            request.setQueryTables(mtables);

            Response resp = this.callerhelper.executeQuery(request);

            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) != 0) {
                this.lrecord = new ArrayList<TgeneMessageTemplatesDesc>();
                MessageHelper.setMessageError(resp);
            } else {
                this.lrecord = (List<TgeneMessageTemplatesDesc>) resp.get(this.beanalias);
                super.postQuery(this.lrecord);
            }

        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    @Override
    public void save() {
        try {
            DtoSave dtosave = super.getDtoSave();
            dtosave.setReturnpk(true); // Para que el core devuelva el pk de los registros nuevos.
            HashMap<String, DtoSave> msave = new HashMap<String, DtoSave>();

            Request request = this.callerhelper.getRequest();
            msave.put(this.beanalias, dtosave); // adicionar metadata de mantenimiento para cada tabla.

            request.setSaveTables(msave);
            Response resp = this.callerhelper.executeSave(request);
            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) == 0) {
                this.postCommit(resp);
                MessageHelper.setMessageInfo(resp);
            } else {
                MessageHelper.setMessageError(resp);
            }
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    @Override
    public void update() throws Exception {
        if (this.record.getPk().getCode() == null) {
            MessageHelper.setMessageError("msg_messageRequired");
            return;
        }
        super.update();
    }

    @Override
    public void postCommit(Response response) throws Exception {
        super.postCommitGeneric(response, this.beanalias);
    }

    /**
     * Llama al Lov de mensajes
     */
    public void openMessageLov() {
        Map<String, List<String>> params = new HashMap<>();
        MessageTemplatesLovController.openLov(params);
    }

    /**
     * Gestiona respuesta del lov de mensajes
     *
     * @param event
     * @throws Exception
     */
    public void onReturnMessageNewLov(SelectEvent event) throws Exception {
        TgeneMessageTemplates t = (TgeneMessageTemplates) event.getObject();
        this.record.getPk().setCode(t.getPk());
        this.record.put("messagedescription", t.getDescription());
    }

    /**
     * Entrega una lista de objetos TgeneLanguage
     *
     * @return lLanguage
     */
    public List<TgeneLanguage> getlLanguage() {
        return lLanguage;
    }

    /**
     * Fija una lista de objetos TgeneLanguage
     *
     * @param lLanguage
     */
    public void setlLanguage(List<TgeneLanguage> lLanguage) {
        this.lLanguage = lLanguage;
    }

}
